// dataitem.cpp : implementation file
//

#include "stdafx.h"
#include "notexfer.h"
#include "dataitem.h"
#include "messaged.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDataItem dialog


CDataItem::CDataItem(CWnd* pParent /*=NULL*/, int nExp)
   : CDialog(CDataItem::IDD, pParent)
{
   //{{AFX_DATA_INIT(CDataItem)
      // NOTE: the ClassWizard will add member initialization here
   //}}AFX_DATA_INIT
   
   m_nExport = nExp;
}

void CDataItem::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CDataItem)
      // NOTE: the ClassWizard will add DDX and DDV calls here
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDataItem, CDialog)
   //{{AFX_MSG_MAP(CDataItem)
   ON_WM_CREATE()
   ON_BN_CLICKED(IDC_DATAITEM_BT_LIST, OnDataitemBtList)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CDataItem message handlers

BOOL CDataItem::OnInitDialog()
{
   CString szMessage;
   
   CDialog::OnInitDialog();
   
   //----- Set prompt
   if (m_nExport)
      szMessage.LoadString (IDS_STR_EXPORT_ITEM);
   else
      szMessage.LoadString (IDS_STR_IMPORT_ITEM);
   SetDlgItemText (IDC_STATIC, szMessage);
   
   return TRUE;  // return TRUE  unless you set the focus to a control
}

int CDataItem::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   if (CDialog::OnCreate(lpCreateStruct) == -1)
      return -1;
   
   //----- Set title
   SetWindowText ("Choose Notecard");
   return 0;
}

void CDataItem::OnOK()
{
   CComboBox *pCBox;                   // Pointer to combo box

   pCBox = (CComboBox *) GetDlgItem (IDD_DATAITEM_CB_ITEM);

   //----- Get the value from the combo and return OK
   pCBox-> GetWindowText (m_sDataItem);
   
   //----- Check for no value
   if (m_sDataItem.IsEmpty())
   {
      ::MessageBeep (MB_ICONEXCLAMATION);
      return;
   }
   CDialog::OnOK();
}

void CDataItem::OnDataitemBtList()
{
   long lRc;                           // Return code
   CComboBox *pCBox;                   // Pointer to combo box
   int nList;                          // Count data items found
   HANDLE hList;                       // Handle to data items list
   LPSTR pList;                        // Pointer to list
   LPSTR pTemp;                        // Temp used to traverse list
   CButton *pButton;

   //----- Get current data items list
   pButton = (CButton *)GetDlgItem (IDC_DATAITEM_BT_LIST);
   pButton-> EnableWindow (FALSE);
   lRc = MX_GetDataNames (NOTECARDXFER_PACKAGE);
   pButton-> EnableWindow (TRUE);

   //----- Check return value
   if (HIWORD(lRc) == 0xFFFF)
   {
      int nRc = LOWORD(lRc);
      switch (nRc)
      {
         case MX_ERR_CONNECT:
            nRc = IDS_ERR_CONNECTED;
            break;
         case MX_ERR_FILE:
            nRc = IDS_ERR_EXPORT_FILE;
            break;
         case MX_ERR_NOFUNCTION:
            nRc = IDS_ERR_NOT_IMPLEMENTED;
            break;
         case MX_ERR_NOPACKAGE:
            nRc = IDS_ERR_PACKAGE_NOTFOUND;
            break;
         default:
            nRc = IDS_ERR_EXPORT;
      }
      
      CMessageDialog messageDlg (nRc);
      messageDlg.DoModal();
      return;
   }
   
   //----- Reset list
   pCBox = (CComboBox *) GetDlgItem (IDD_DATAITEM_CB_ITEM);
   pCBox-> ResetContent();
   
   //----- Isolate handle, count
   nList = HIWORD (lRc);
   hList = (HANDLE)LOWORD (lRc);
   pList = (LPSTR)GlobalLock (hList);
   pTemp = strtok (pList, "\t");
   
   //----- Iterate, adding names to list
   while (pTemp != NULL)
   {
      pCBox-> AddString (pTemp);      
      pTemp = strtok (NULL, "\t");
   }

   //----- Free the memory block
   GlobalUnlock (hList);
   GlobalFree (hList);
            
   pCBox-> SetCurSel (0);
}
